//////////////////////////////////////////////////////////////////////
//
// Resample.cpp
//
// 1999. 1.11 newtype   - Indentation
// 24bit ƴ 8bit 256 coloró ƾ ʿ

typedef unsigned char BYTE;

void Resample(double F[], BYTE *IN, BYTE *OUT, int INlen, int OUTlen)
{
	int u,x;
	double acc, intensity, inpos[1024], INSFAC, INSEG, OUTSEG;

	//   ȼ  Է ε ̸ 
	u = 0;

	for( x = 0; x < OUTlen; x++ )
	{
		while(F[u+1]<x)
			u++;
		inpos[x] = u+(double)(x-F[u])/(F[u+1]-F[u]);
	}

	// RED ä   
	//////////////////////////////////////////////////////////////////////
	INSEG = 1.0;              // ʱġ : Էȼ Ѱ  
	OUTSEG = inpos[1];        // 1  ȼ  Է ȼ 
	INSFAC = OUTSEG;          // 1/ 
	acc = 0.0;                // 

	//   ȼ  
	x = u = 0;
	while( x < OUTlen - 1 )
	{
		// 籸(reconstruction)   ̼(interpolation)
		intensity = (INSEG * IN[u*3]) + ((1-INSEG) * IN[(u+1)*3]);

		// INSEG < OUTSEG : Է ȼѰ  .
		if( INSEG < OUTSEG ) 
		{
			acc += (intensity * INSEG); // ġ  Ŵ
			OUTSEG -= INSEG;            // INSEG κ ä
			INSEG = 1.0;                // ο Է ȼ ʿ
			u++;                        //  Է ȼ 
		}
		else
		{
			// INSEG >= OUTSEG : Է ȼ  ȼ µ   .
			acc += (intensity * OUTSEG);		// ġ  Ŵ 
			OUT[x*3] = (BYTE)(acc / INSFAC);    // ȭ (acc)  ȼ ʱȭ
			acc = 0.0;							//   ȼ ,(acc)  
			INSEG -= OUTSEG;					// Է OUTSEGκ  
			x++;								//   ȼ 
			INSFAC = inpos[x+1] - inpos[x];		// INSFAC ʱȭ
			OUTSEG = INSFAC;					// SIZFAC ʱȭ 
		}
	}

	// GREEN ä  
	//////////////////////////////////////////////////////////////////////
	INSEG = 1.0;              // ʱġ : Էȼ Ѱ  
	OUTSEG = inpos[1];        // 1  ȼ  Է ȼ 
	INSFAC = OUTSEG;          // 1/ 
	acc = 0.0;                // 

	//   ȼ  
	x = u = 0;
	while( x < OUTlen - 1 )
	{
		// 籸(reconstruction)   ̼(interpolation)
		intensity = (INSEG * IN[u*3+1]) + ((1-INSEG) * IN[(u+1)*3+1]);

		// INSEG < OUTSEG : Է ȼѰ  .
		if( INSEG < OUTSEG )
		{
			acc += (intensity * INSEG); // ġ  Ŵ 
			OUTSEG -= INSEG;            // INSEG κ ä
			INSEG = 1.0;                // ο Է ȼ ʿ
			u++;                        //  Է ȼ 
		}
		else
		{
			// INSEG >= OUTSEG : Է ȼ  ȼ µ   .
			acc += (intensity * OUTSEG);		// ġ  Ŵ
			OUT[x*3+1] = (BYTE)(acc / INSFAC);  // ȭ (acc)  ȼ ʱȭ
			acc = 0.0;							//   ȼ ,(acc) 
			INSEG -= OUTSEG;					// Է OUTSEGκ  
			x++;								//   ȼ
			INSFAC = inpos[x+1] - inpos[x];		// INSFAC ʱȭ
			OUTSEG = INSFAC;					// SIZFAC ʱȭ
		}
	}

	// BLUE ä  
	//////////////////////////////////////////////////////////////////////
	INSEG = 1.0;              // ʱġ : Էȼ Ѱ  
	OUTSEG = inpos[1];        // 1  ȼ  Է ȼ 
	INSFAC = OUTSEG;          // 1/ 
	acc = 0.0;                // 

	//   ȼ  
	x = u = 0;

	while( x < OUTlen - 1 )
	{
		// 籸(reconstruction)   ̼(interpolation)
		intensity = (INSEG * IN[u*3+2]) + ((1-INSEG) * IN[(u+1)*3+2]);

		// INSEG < OUTSEG : Է ȼѰ  .
		if( INSEG < OUTSEG )
		{
			acc += (intensity * INSEG); // ġ  Ŵ 
			OUTSEG -= INSEG;            // INSEG κ ä
			INSEG = 1.0;                // ο Է ȼ ʿ
			u++;                        //  Է ȼ 
		}
		else
		{
			// INSEG >= OUTSEG : Է ȼ  ȼ µ   .
			acc += (intensity * OUTSEG);		// ġ  Ŵ
			OUT[x*3+2] = (BYTE)(acc / INSFAC);  // ȭ (acc)  ȼ ʱȭ
			acc = 0.0;							//   ȼ ,(acc) 
			INSEG -= OUTSEG;					// Է OUTSEGκ  
			x++;								//   ȼ
			INSFAC = inpos[x+1] - inpos[x];		// INSFAC ʱȭ
			OUTSEG = INSFAC;					// SIZFAC ʱȭ
		}
	}
}

