#include <stdio.h>
#include "dib.h"

LPBYTE
dibLoad( LPCTSTR lpszFile )
{
	FILE				*fp;
	LPBYTE				lpData;
	BITMAPFILEHEADER	fileHdr;
//	BITMAPINFOHEADER	infoHdr;

	fp = fopen( lpszFile, "rb" );
	if( !fp )
		return NULL;

	fread( &fileHdr, sizeof fileHdr, 1, fp );

	lpData = (LPBYTE)malloc( fileHdr.bfSize -  sizeof( fileHdr ) );
	if( !lpData )
		return NULL;

	fread( lpData, fileHdr.bfSize -  sizeof( fileHdr ), 1, fp );

	return lpData;
}

//---------------------------------------------------------------------
// dibHeight
//
// DIB ̸ 
//---------------------------------------------------------------------
int
dibHeight( LPBYTE lpDIB )
{
	LPBITMAPINFOHEADER lpbmi;
	LPBITMAPCOREHEADER lpbmc;

	lpbmi = (LPBITMAPINFOHEADER) lpDIB;
	lpbmc = (LPBITMAPCOREHEADER) lpDIB;

	if (lpbmi->biSize == sizeof (BITMAPINFOHEADER))
		return lpbmi->biHeight;
	else
		return (DWORD) lpbmc->bcHeight;
}


//---------------------------------------------------------------------
// dibWidth
//
// DIB ʺ 
//---------------------------------------------------------------------
int
dibWidth( LPBYTE lpDIB )
{
	LPBITMAPINFOHEADER lpbmi;
	LPBITMAPCOREHEADER lpbmc;


	lpbmi = (LPBITMAPINFOHEADER) lpDIB;
	lpbmc = (LPBITMAPCOREHEADER) lpDIB;

	if (lpbmi->biSize == sizeof (BITMAPINFOHEADER))
		return lpbmi->biWidth;
	else
		return (DWORD) lpbmc->bcWidth;
}

LPBYTE
dibData( LPBYTE lpDIB )
{
	LPBITMAPINFOHEADER lpbmi;

	lpbmi = (LPBITMAPINFOHEADER) lpDIB;

	return lpDIB + lpbmi->biSize;
}
